Use random password if bootoption 'ssh' doesn't have an option.
[grml-autoconfig.git] / autoconfig.functions
index 1e6798a..debf31f 100755 (executable)
@@ -4,7 +4,7 @@
 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
-# Latest change: Sam Mär 17 23:52:56 CET 2007 [mika]
+# Latest change: Fre Aug 15 23:06:21 CEST 2008 [mika]
 ################################################################################
 
 # {{{ path, variables, signals, umask, zsh
@@ -13,6 +13,11 @@ DEBUG="/dev/null"
 KERNEL="$(uname -r)"
 umask 022
 
+# old linuxrc version:
+[ -d /cdrom ]      && export LIVECD_PATH=/cdrom
+# new initramfs layout:
+[ -d /live/image ] && export LIVECD_PATH=/live/image
+
 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
 [ -z "$PS1" ] && trap "" 2 3 11
 
@@ -91,12 +96,12 @@ mount_sys(){
 # {{{ Read in boot parameters
 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
 CMDLINE="$(cat /proc/cmdline)"
-[ -d /cdrom/bootparams/ ] && CMDLINE="$CMDLINE $(cat /cdrom/bootparams/* | tr '\n' ' ')"
+[ -d "${LIVECD_PATH}"/bootparams/ ] && CMDLINE="$CMDLINE $(cat ${LIVECD_PATH}/bootparams/* | tr '\n' ' ')"
 # }}}
 
 # {{{ Check if we are running from the grml-CD or HD
 INSTALLED=""
-[ -e /GRML/etc/grml_cd ] || INSTALLED="yes"
+[ -e /etc/grml_cd ] || INSTALLED="yes"
 
 # testcd
 TESTCD=""
@@ -116,26 +121,29 @@ fi
 
 # {{{ debug
 config_debug(){
- if checkbootparam "debug"; then
-   BOOTDEBUG="yes"
- fi
- if stringinstring "BOOT_IMAGE=debug " "$CMDLINE" ; then
-   BOOTDEBUG="yes"
- fi
+ checkbootparam "debug"                        && BOOTDEBUG="yes"
+ stringinstring "BOOT_IMAGE=debug " "$CMDLINE" && BOOTDEBUG="yes"
+
  rundebugshell(){
   if [ -n "$BOOTDEBUG" ]; then
-    einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
-    eindent
-    if [ -r /etc/grml/screenrc ] ; then
-       einfo "Starting GNU screen to be able to use a full featured shell environment."
-       einfo "Just exit the shells (and therefore screen) to continue boot process..."
-       /bin/zsh -c "screen -c /etc/grml/screenrc"
-    else
-      einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
-      einfo "Just exit the shell to continue boot process..."
-      /bin/zsh
-    fi
-    eoutdent
+     einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
+     if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
+        einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
+        einfo "Just exit the shell to continue boot process..."
+        /bin/zsh
+     else
+        eindent
+        if [ -r /etc/grml/screenrc ] ; then
+           einfo "Starting GNU screen to be able to use a full featured shell environment."
+           einfo "Just exit the shells (and therefore screen) to continue boot process..."
+           /bin/zsh -c "screen -c /etc/grml/screenrc"
+        else
+           einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
+           einfo "Just exit the shell to continue boot process..."
+           /bin/zsh
+        fi
+        eoutdent
+     fi
   fi
  }
 }
@@ -143,25 +151,20 @@ config_debug(){
 
 # {{{ log
 config_log(){
-if checkbootparam "log"; then
-  export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
-  touch $DEBUG
-  einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot."
-  eindent
-    einfo "Starting bootlogd."
-    bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
-  eoutdent
+if checkbootparam "log" || checkbootparam "debug" ; then
+   export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
+   touch $DEBUG
+   einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
+   eindent
+     einfo "Starting bootlogd." # known to be *very* unreliable :(
+     bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
+   eoutdent
 else
-  DEBUG="/dev/null"
+   DEBUG="/dev/null"
 fi
 }
 # }}}
 
-# {{{ Check if we are in interactive startup mode
-INTERACTIVE=""
-stringinstring "BOOT_IMAGE=expert " "$CMDLINE" && INTERACTIVE="yes"
-# }}}
-
 # {{{ set firmware timeout via bootparam
 config_fwtimeout(){
  if checkbootparam fwtimeout ; then
@@ -262,47 +265,58 @@ config_language(){
 
    # write keyboard related variables to file for later use
    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
-   echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
-   echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
-   echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
-   echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
+   if ! [ -e /etc/sysconfig/keyboard ] ; then
+      echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
+      echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
+      echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
+      echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
+   fi
  fi
 
  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
 
-  # Set default keyboard before interactive setup
-  if [ -n "$KEYTABLE" ] ; then
-   einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
-   loadkeys -q $KEYTABLE &
-   eend $?
-  fi
+ # activate unicode console if running within utf8 environment
+ if [ -r /etc/default/locale ] ; then
+    if grep -q "LANG=.*UTF" /etc/default/locale ; then
+       einfo "Setting up unicode environment."
+       unicode_start 2>>$DEBUG ; eend $?
+    fi
+ fi
 
-  if [ -n "$CONSOLEFONT" ] ; then
-     einfo "Running consolechars using ${CONSOLEFONT}"
-     consolechars -f $CONSOLEFONT || consolechars -d
-     eend $?
-  fi
+ # Set default keyboard before interactive setup
+ if [ -n "$KEYTABLE" ] ; then
+    einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
+    loadkeys -q $KEYTABLE &
+    eend $?
+ fi
 
-  # we have to set up all consoles, therefore loop it over all ttys:
-  if [ -n "$CHARMAP" ] ; then
-     einfo "Running consolechars for ${CHARMAP}"
-     NUM_CONSOLES=`fgconsole --next-available`
-     NUM_CONSOLES=`expr ${NUM_CONSOLES} - 1`
-     [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
-     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
-       consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
-     done
-     eend ${RC}
-  fi
+ # we have to set up all consoles, therefore loop it over all ttys:
+ NUM_CONSOLES=$(fgconsole --next-available)
+ NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
+ [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
+ CUR_CONSOLE=$(fgconsole)
 
-  # activate unicode console if running within utf8 environment
-  if [ -r /etc/default/locale ] ; then
-     if grep -q "LANG=.*UTF" /etc/default/locale ; then
-        einfo "Setting up unicode environment."
-        unicode_start
-        eend $?
-     fi
-  fi
+ if [ -n "$CHARMAP" ] ; then
+    einfo "Running consolechars for ${CHARMAP}"
+    for vc in `seq 0 ${NUM_CONSOLES}`  ; do
+        consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
+    done
+    [ -n "$CUR_CONSOLE" ] && chvt $CUR_CONSOLE
+    eend $RC
+ fi
+
+ if checkbootparam noconsolefont ; then
+    ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
+ else
+    if [ -n "$CONSOLEFONT" ] ; then
+       einfo "Running consolechars using ${CONSOLEFONT}"
+       for vc in `seq 0 ${NUM_CONSOLES}`  ; do
+           consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT ; RC=$?
+       done
+       [ -n "$CUR_CONSOLE" ] && chvt $CUR_CONSOLE
+       eend $?
+    fi
+ fi
 
  eoutdent
 }
@@ -338,31 +352,33 @@ config_userfstab(){
 config_time(){
  # don't touch the files if running from harddisk:
  if [ -z "$INSTALLED" ]; then
-  UTC=""
-  checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
-  checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
-  # hwclock uses the TZ variable
-  if [ -r /etc/default/locale ] ; then
-     . /etc/default/locale
-  else
-     TZ=Europe/Vienna
-  fi
-  ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1) ; RC=$?
-  if [ -n "$ERROR" ] ; then
-     eindent
-     ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1)
-     if [ -n "$ERROR" ] ; then
-        eerror "Problem running hwclock: $ERROR" ; eend 1
-     fi
-     eoutdent
-  fi
+    UTC=""
+    checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
+    checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
+    # hwclock uses the TZ variable
+    [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
+    [ -n "$TZ" ] || TZ=Europe/Vienna
+
+    if ! [ -r /dev/rtc ] ; then
+      ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
+    else
+      ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
+      if [ -n "$ERROR" ] ; then
+         eindent
+         ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
+         if [ -n "$ERROR" ] ; then
+            eerror "Problem running hwclock: $ERROR" ; eend 1
+         fi
+         eoutdent
+      fi
+    fi
  fi
 }
 # }}}
 
 # {{{ print kernel info
 config_kernel(){
-  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMWare${NORMAL}"
+  vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
   if [ -r /proc/cpuinfo ] ; then
@@ -383,16 +399,34 @@ config_kernel(){
 # {{{ vmware specific stuff
 config_vmware(){
 if checkbootparam novmware ; then
- ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
  ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
 else
- if [ -z "$INSTALLED" ]; then
-  if vmware-detect ; then
-    if [ -r /etc/X11/xorg.conf.vmware ] ; then
-      einfo "Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
-      cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
-    fi
-  fi
- fi
+   if [ -z "$INSTALLED" ] ; then
+      if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
+         if ! checkbootparam qemu ; then
+            if [ -r /etc/X11/xorg.conf.vmware ] ; then
+               einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
+               cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
+            fi
+         fi
+      elif [ -r /proc/acpi/battery/BAT0/info -a -r /etc/X11/xorg.conf.virtualbox ] ; then
+         if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
+            einfo 'Virtual Box: Copying /etc/X11/xorg.conf.virtualbox to /etc/X11/xorg.conf'
+            cp /etc/X11/xorg.conf.virtualbox /etc/X11/xorg.conf ; eend $?
+         fi
+      fi
+   fi
+fi
+}
+# }}}
+
+# {{{ qemu specific stuff
+config_qemu(){
+if checkbootparam qemu ; then
+   if [ -r /etc/X11/xorg.conf.example ] ; then
+      einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
+      cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
+   fi
 fi
 }
 # }}}
@@ -414,22 +448,17 @@ fi
 }
 # }}}
 
-# update_progress {{{
-update_progress(){
-  # be sure we are non-blocking
-  (echo "$1" > /etc/sysconfig/progress) &
-}
-# }}}
-
 # {{{ timezone
 config_timezone(){
  # don't touch the files if running from harddisk:
  if [ -z "$INSTALLED" ]; then
-  einfo "Setting timezone."
-  KTZ="$(getbootparam tz 2>>$DEBUG)"
-  [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
-  rm -f /etc/localtime
-  cp "/usr/share/zoneinfo/$TZ" /etc/localtime && eend 0
+    KTZ="$(getbootparam tz 2>>$DEBUG)"
+    if [ -n "$KTZ" ] ; then
+       einfo "Setting timezone."
+       [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
+       rm -f /etc/localtime
+       cp "/usr/share/zoneinfo/$TZ" /etc/localtime ; eend $?
+    fi
  fi
 }
 # }}}
@@ -494,10 +523,21 @@ fi
 # activate serial console {{{
 config_console(){
 if checkbootparam "console"; then
-  einfo "Bootoption (for serial) console detected. Activating mgetty."
+  einfo "Bootoption (for serial) console detected."
+  eindent
+    if [ -r /etc/mgetty/mgetty.config ] ; then
+       MODE=$(getbootparam console | awk -F, '{print $2}')
+       MODE=${MODE%%n*}
+       [ -n "$MODE" ] || MODE=9600 # default mode
+       einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
+       sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
+    fi
+
+    einfo "Activating mgetty."
     sed -i 's/^#T0/T0/' /etc/inittab
     sed -i 's/^#T1/T1/' /etc/inittab
-  /sbin/telinit q ; eend $?
+    /sbin/telinit q ; eend $?
+  eoutdent
 fi
 }
 # }}}
@@ -558,21 +598,28 @@ config_fix_passwd(){
 # {{{ CD Checker
 config_testcd(){
 if [ -n "$TESTCD" ]; then
-  einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
-  einfo "Reading files and checking against GRML/md5sums, this may take a while..."
-  echo -n "${RED}"
-  ( cd /cdrom/GRML/ ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log )
-  if [ "$?" = "0" ]; then
-    echo " ${GREEN}Everything looks OK${NORMAL}"
-    else
-    echo "${RED} *** CHECKSUM FAILED FOR THESE FILES:                          ***"
-    egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
-    echo "${RED} *** DATA ON YOUR CD MEDIUM IS POSSIBLY INCOMPLETE OR DAMAGED, ***${NORMAL}"
-    echo "${RED} *** OR YOUR COMPUTER HAS BAD RAM.                             ***${NORMAL}"
-    echo -n "${CYAN}Hit return to contine, or press the reset button to quit.${NORMAL}\a\a\a "
-    read a
-  fi
-  eend 0
+   einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
+   einfo "Reading files and checking against GRML/md5sums, this may take a while..."
+   echo -n "${RED}"
+
+   if [ -n "${LIVECD_PATH}"/GRML ] ; then
+      ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
+   else
+      echo "${RED} *** Error: Could not find md5sum file.                           ***"
+   fi
+
+   if [ "$RC" = "0" ]; then
+      einfo "Everything looks OK" ; eend 0
+   else
+      eerror 'Checksum failed for theses files:' ; eend 1
+      egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
+      eerror 'Data on the grml medium is possibly incomplete/damaged or...'
+      eerror '... RAM of your computer is broken.' ; eend 1
+      einfon "Hit return to continue, or press the reset button to quit."
+     read a
+   fi
+
+   eend 0
 fi
 }
 # }}}
@@ -664,18 +711,20 @@ if checkbootparam "blacklist" ; then
   einfo "Bootoption blacklist found."
   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
   if [ -n "$BLACK" ] ; then
-    einfo "Blacklisting module ${BLACK} via /etc/modprobe.d/grml."
-    echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
-    echo "blacklist $BLACK"     >> /etc/modprobe.d/grml
-    echo "alias     $BLACK off" >> /etc/modprobe.d/grml
-    echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
+    for module in $(echo ${BLACK//,/ }) ; do
+        einfo "Blacklisting module ${module} via /etc/modprobe.d/grml."
+        echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
+        echo "blacklist $module"     >> /etc/modprobe.d/grml
+        echo "alias     $module off" >> /etc/modprobe.d/grml
+        echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
+    done
   else
-   eerror "No given module for blacklist found. Blacklisting will not work therefor."
+   eerror "No given module for blacklist found. Blacklisting will not work therefore."
   fi
  else
-  ewarn "Backlisting via bootoption does not work on harddisk installations." ; eend 1
+  ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
   eindent
-   einfo "Please blacklist the module(s) via /etc/modprobe.d/blacklist."
+   einfo "Please blacklist the module(s) manually using the 'blacklist' script."
   eoutdent
  fi
 fi
@@ -686,9 +735,11 @@ fi
 config_acpi_apm(){
 if [ -d /proc/acpi ]; then
   if checkbootparam "noacpi"; then
-    ewarn "Skipping ACPI Bios detection as requested on boot commandline." ; eend 0
+    ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
+  elif checkbootparam "nogrmlacpi" ; then
+    ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
   else
-    einfo "ACPI Bios found, activating modules: "
+    einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
     eindent
     found=""
     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
@@ -705,10 +756,10 @@ if [ -d /proc/acpi ]; then
     else
       ewarn "(none)" ; eend 1
     fi
-    if ! [ -S /var/run/acpid.socket ] ; then
+    if ! ps x | grep -q /usr/sbin/acpid ; then
       if ! [ -r /var/run/dbus/pid ] ; then
         einfo "Starting acpi daemon."
-        /etc/init.d/acpid start >>$DEBUG ; eend $?
+        /etc/init.d/acpid start 1>>$DEBUG 2>&1 ; eend $?
       else
         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
         eerror "Solution: please activate acpid via /etc/runlevel.conf"
@@ -836,24 +887,8 @@ fi
 
 # {{{ Interactive configuration
 config_interactive(){
-if [ -n "$INTERACTIVE" ] ; then
-einfo "Entering interactive configuration second stage."
-
-  echo " ${GREEN}Your console keyboard defaults to: ${MAGENTA}${KEYTABLE}"
-  echo -n "${CYAN}Do you want to (re)configure your console keyboard?${NORMAL} [Y/n] "
-  read a
-  [ "$a" != "n" ] && /usr/sbin/dpkg-reconfigure console-data ; eend $?
-
-  echo -n "${CYAN}Do you want to (re)configure your soundcard?${NORMAL} [Y/n] "
-  read a
-  [ "$a" != "n" ] && alsaconf && ( exec aumix -m 0 >>$DEBUG 2>&1 & ) ; eend $?
-
-  echo -n "${CYAN}Do you want to (re)configure your graphics (X11) subsystem?${NORMAL} [Y/n] "
-  read a
-  [ "$a" != "n" ] && xorgcfg -textmode ; eend $?
-  echo " ${GREEN}Interactive configuration finished. Everything else should be fine for now.${NORMAL}"
-fi
-eend 0
+  ewarn "config_interactive is deprecated nowadays."
+  ewarn "Please set CONFIG_INTERACTIVE='no' in /etc/grml/autoconfig" ; eend 0
 }
 # }}}
 
@@ -964,120 +999,125 @@ fi
 config_fstab(){
 
 NOSWAP="yes" # we do not use swap by default!
-if checkbootparam "swap" -o checkbootparam "anyswap" ; then
+if checkbootparam "swap" || checkbootparam "anyswap" ; then
    NOSWAP=''
+   checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
 fi
 
-if checkbootparam "nofstab" -o checkbootparam "forensic" ; then
+if checkbootparam "nofstab" || checkbootparam "forensic" ; then
   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
 else
-  checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
   iszsh && setopt nonomatch
   if [ -x /usr/sbin/rebuildfstab ] ; then
-    config_userfstab || fstabuser=grml
-    /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
+     config_userfstab || fstabuser=grml
+     /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
   else
-    ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
+     ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
   fi
-  if [ -e /var/run/rebuildfstab.pid ]; then
-    # Another instance of rebuildfstab, probably from hotplug, is still running, so just wait.
-    sleep 8
-  fi
-fi
-# Scan for swap, config, homedir
-if [ -z "$NOSWAP" ]; then
-   einfo "Searching for swap partition(s) as requested."
-fi
-GRML_IMG=""
-GRML_SWP=""
-HOMEDIR="$(getbootparam home)"
-if [ -n "$partitions" ]; then
- while read p m f relax; do
-  case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
-  partoptions="users,exec"
-  fnew=""
-  case "$f" in swap)
-   eindent
-   if [ -n "$NOSWAP" ]; then
-      if [ -z "$INSTALLED" ] ; then
-         ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)" ; eend 0
-      fi
-   else
-     case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
-             S1SUSP|S2SUSP|pmdisk|[zZ]*)
-                if [ -n "$ANYSWAP" ] ; then
-                  einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
-                  swapon $p 2>>$DEBUG ; eend $?
-                else
-                  ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
-                fi
-               ;;
-             *)
-                if [[ "$p" == LABEL* ]] ; then
-                   p=$(blkid -t $p | awk -F: '{print $1}')
-                fi
-                if grep -q $p /proc/swaps ; then
-                   ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
-                else
-                   einfo "Using swap partition ${WHITE}${p}${NORMAL}."
-                   swapon $p 2>>$DEBUG ; eend $?
-                fi
-               ;;
-     esac
-   fi
-   eoutdent
-   continue
-   ;;
-  esac
-# Create mountdir if not already present, but don't try to create stuff like /proc/bus/usb
-# Notice: grml-rebuildfstab >= 0.3-1 handles this now
-#  case "$m" in *none*|*proc*|*sys*|'') continue ;; esac
-#  [ -d "$m" ] || mkdir -p "$m"
-# WARNING: NTFS RW mounts are only safe since Kernel 2.6.11
-  [ "$f" = "ntfs" -a "${KERNEL%.*}" != "2.6" ] && continue
-  MOUNTOPTS="ro"
-  case "$f" in
-    vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
-    ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
-    *) continue ;;
-    # *) NONEFOUND='1'; continue ;;
-  esac
-  if [ -z "$NOSWAP" ] ; then
-     mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG || continue
-     # Activate swapfile, if exists
-     SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
-  fi
-  if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
-   mount -o remount,rw $m
-   if swapon "$SWAPFILE" 2>>$DEBUG ; then
-    einfo "Using GRML swapfile ${SWAPFILE}."
-    fnew="$SWAPFILE swap swap defaults 0 0"
-    stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
-    GRML_SWP="$GRML_SWP $SWAPFILE"
-    eend 0
-   fi
-   mount -o remount,ro $m 2>>$DEBUG
-  fi
-  IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
-  if [ -z "$INSTALLED" -a -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
-   if [ -n "$HOMEDIR" ]; then
-    if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
-     continue
-    fi
-   fi
-   if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
-    GRML_IMG="$IMAGE"
-    mount -o remount,ro $m 2>>$DEBUG
-   fi
-  fi
-  eend 0
-  # Umount, if not in use
-  umount -r $m 2>/dev/null
- done <<EOT
-$(cat /etc/fstab)
+fi # checkbootparam nofstab/forensic
+
+# Scan for swap, config, homedir - but only in live-mode
+if [ -z "$INSTALLED" ] ; then
+   [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
+   GRML_IMG=""
+   GRML_SWP=""
+   HOMEDIR="$(getbootparam home)"
+   if [ -n "$partitions" ]; then
+      while read p m f relax; do
+        case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
+        partoptions="users,exec"
+        fnew=""
+        # it's a swap partition?
+        case "$f" in swap)
+          eindent
+          if [ -n "$NOSWAP" ]; then
+             ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
+             eend 0
+          else
+             case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
+                   S1SUSP|S2SUSP|pmdisk|[zZ]*)
+                     if [ -n "$ANYSWAP" ] ; then
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
+                        swapon $p 2>>$DEBUG ; eend $?
+                     else
+                        ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
+                     fi
+                     ;;
+                   *)
+                     if [[ "$p" == LABEL* ]] ; then
+                        p=$(blkid -t $p | awk -F: '{print $1}')
+                     fi
+                     if grep -q $p /proc/swaps ; then
+                        ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
+                     else
+                        if [ -b "$p" ] ; then
+                        einfo "Using swap partition ${WHITE}${p}${NORMAL}."
+                        swapon $p 2>>$DEBUG ; eend $?
+                        else
+                        ewarn "$p is not a valid block device - not using it therefore." ; eend 0
+                        fi
+                     fi
+                     ;;
+             esac # dd-check
+          fi # -n "$NOSWAP
+          eoutdent
+          continue
+          ;;
+        esac # it's a swap partition?
+
+        # mount read-only
+        MOUNTOPTS="ro"
+        case "$f" in
+          vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
+          ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
+          *) continue ;;
+          # *) NONEFOUND='1'; continue ;;
+        esac
+
+        # use a swapfile
+        if [ -z "$NOSWAP" ] ; then
+           mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
+           # Activate swapfile, if exists
+           SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
+        fi
+        if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
+           mount -o remount,rw $m && MOUNTED=1
+           if swapon "$SWAPFILE" 2>>$DEBUG ; then
+              eindent
+                einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
+              eoutdent
+              fnew="$SWAPFILE swap swap defaults 0 0"
+              stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
+              GRML_SWP="$GRML_SWP $SWAPFILE"
+              eend 0
+           fi
+           mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+        fi
+
+        # use a image as home
+        IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
+        if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
+           if [ -n "$HOMEDIR" ]; then
+              if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
+                 continue
+              fi
+           fi
+           if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
+              GRML_IMG="$IMAGE"
+              mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
+           fi
+        fi
+        eend 0
+
+        # Umount, if not in use
+        [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
+
+      done <<EOT
+      $(cat /etc/fstab)
 EOT
-fi
+   fi # -n $partitions
+fi # -z $INSTALLED
 }
 # }}}
 
@@ -1134,6 +1174,10 @@ else
     sleep 1
     eend 0
   done
+  if [ -n "$INSTALLED" ] ; then
+     ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
+     eend 0
+  fi
 fi
 }
 # }}}
@@ -1196,78 +1240,143 @@ config_cpu(){
 if checkbootparam "nocpu"; then
   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
 else
-  if ! [ -x /etc/init.d/powernowd ] ; then
-    ewarn "Skipping CPU detection as powernowd dependencies are not fulfilled." ; eend 1
-  elif [ ! -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] ; then
-    ewarn "Skipping CPU detection as module dependencies are not fulfilled." ; eend 1
+  # check module dependencies
+  cpufreq_check() {
+   if ! [ -e /lib/modules/${KERNEL}/kernel/arch/x86/kernel/cpu/cpufreq ] ; then
+      if [ -e /lib64 ] ; then
+         [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
+      else
+         [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
+      fi
+   fi
+  }
+
+  if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
+     einfo "Detecting CPU:"
+     CPU=$(awk -F: '/^processor/{printf "      Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
+     echo $CPU | sed 's/ \{1,\}/ /g'
+     eend 0
   else
-    if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
-      einfo "Detecting CPU:"
-      CPU=$(awk -F: '/^processor/{printf "     Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
-      echo $CPU | sed 's/ \{1,\}/ /g'
-      eend 0
-    else
-      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
-    fi
-    if /usr/sbin/laptop-detect ; then
-    einfo "Detected Laptop - trying to use cpu frequency scaling:"
-#      loadcpumod() {
-#      for module in /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq/*.ko /lib/modules/${KERNEL}/kernel/drivers/cpufreq/*.ko ; do
-#    # modprobe ${${${${(f)"$(_call_program modules ${(M)words[1]##*/}modprobe -l | grep cpufreq 2>>$DEBUG)"}:#}##*/}%.*}
-#        modprobe `basename ${module%%\.ko}` 1>>$DEBUG 2>&1
-#      done
-#      }
-#    CPU=$(grep 'model name' /proc/cpuinfo | cut -b14- | head -1)
-#    eindent
-#    if [[ $CPU = *Intel* ]] ; then
-#      einfo "Detected CPU is of type Intel - loading modules and starting cpudyn."
-#      local DETECTED=1
-#      loadcpumod
-#      /etc/init.d/cpudyn start 1>>$DEBUG ; eend $?
-#    fi
-#    if [[ $CPU = *AMD* ]] ; then
-#      einfo "Detected CPU is of type AMD - loading modules and starting powernowd."
-#      local DETECTED=1
-#      loadcpumod
-#      /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
-#    fi
+     einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
+  fi
 
-     eindent
-     if [ -r /usr/bin/cpufreq-detect.sh ] ; then
-       . /usr/bin/cpufreq-detect.sh
-       if [ -n "$MODULE" -a "$MODULE" != none ]; then
-         einfo "Loading module ${MODULE} and starting powernowd."
-         modprobe cpufreq_userspace 1>>$DEBUG
-         modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
-         /etc/init.d/powernowd start 1>>$DEBUG ; eend $?
-       else
-         ewarn "Could not detect an appropriate CPU for use with powernowd - skipping." && eend 1
+  # Disclaimer: sorry for the tons of if/then/else... but this makes sure we use:
+  # * it only if we have the according kernel modules available
+  # * cpufreq only on laptops (check via /usr/sbin/laptop-detect) and not inside Virtual Box
+  # * current version of /etc/init.d/loadcpufreq from Debian (to stay in sync)
+  #   -> parse output of the initscript and output it according to our look'n'feel
+  # * our own cpufreq-detect.sh if /etc/init.d/loadcpufreq isn't present
+  if ! cpufreq_check ; then
+    ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
+  else
+    if /usr/sbin/laptop-detect 1>/dev/null 2>&1 ; then
+       # Virtual Box supports ACPI and laptop-detect returns with '0', so check for it:
+       if [ -r /proc/acpi/battery/BAT0/info ] ; then
+          if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
+             einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
+             return 0
+          fi
        fi
-     fi
-     eoutdent
-   fi
-  fi
-fi
+       einfo "Detected Laptop - trying to use cpu frequency scaling:"
+       eindent
+       if [ -x /etc/init.d/loadcpufreq ] ; then
+          SKIP_CPU_GOVERNOR=''
+          LOADCPUFREQ=$(mktemp)
+          /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
+          if grep -q FATAL "$LOADCPUFREQ" ; then
+             eindent
+               SKIP_CPU_GOVERNOR=1
+               oldIFS="$IFS"
+               IFS="
+"
+                for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
+                    eerror "$line" ; eend $RC
+                done
+                IFS="$oldIFS"
+             eoutdent
+           elif grep -q done "$LOADCPUFREQ" ; then
+             MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
+             if [ -n "$MODULE" -a "$MODULE" != none ]; then
+                einfo "Loading cpufreq kernel module $MODULE" ; eend 0
+             else
+                ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
+             fi
+          fi
+          rm -f $LOADCPUFREQ
+       elif [ -r /usr/bin/cpufreq-detect.sh ] ; then
+          . /usr/bin/cpufreq-detect.sh
+          if [ -n "$MODULE" -a "$MODULE" != none ]; then
+             einfo "Loading modules ${MODULE}"
+             modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
+             RC=$?
+             if [[ $RC == 0 ]]; then
+                eend 0
+             else
+                SKIP_CPU_GOVERNOR=1
+                eend $1
+             fi
+          else
+             ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
+          fi # $MODULE
+       fi # loadcpufreq
+
+       if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
+          einfo "Loading cpufreq_ondemand, setting ondemand governor"
+          if modprobe cpufreq_ondemand ; RC=$? ; then
+             for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
+                 echo ondemand > $file
+             done
+          fi
+          eend $RC
+       fi # cpu-governor
+
+       eoutdent
+
+    fi # laptop-detect
+  fi # cpufreq_check
+fi # checkbootparam nocpu
 }
 # }}}
 
 # {{{ autostart of ssh
 config_ssh(){
 if checkbootparam ssh ; then
-  SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
-  einfo "Bootoption passwd found."
-  if [ -n "$SSH_PASSWD" ] ; then
-    echo "grml:$SSH_PASSWD" | chpasswd -m
-    einfo "Starting secure shell server in background."
-    /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
-    /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
-    eend 0
-  else
-    eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
-  fi
-  eindent
-    ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
-  eoutdent
+   SSH_PASSWD=''
+   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
+   einfo "Bootoption ssh found, trying to set password for user grml."
+   eindent
+   if [ -z "$SSH_PASSWD" ] ; then
+      if [ -x /usr/bin/pwgen ] ; then
+         SSH_PASSWD="$(pwgen -1 8)"
+      elif [ -x /usr/bin/hexdump ] ; then
+         SSH_PASSWD="$(dd if=/dev/urandom bs=14 count=1 2>/dev/null | hexdump | awk '{print $3 $4}')"
+      elif [ -n "$RANDOM" ] ; then
+         SSH_PASSWD="grml${RANDOM}"
+      else
+         SSH_PASSWD=''
+         eerror "Empty passphrase and neither pwgen nor hexdump nor \$RANDOM found. Skipping."
+         eend 1
+      fi
+
+      if [ -n "$SSH_PASSWD" ] ; then
+         ewarn "No given password for ssh found. Using random password: $SSH_PASSWD" ; eend 0
+      fi
+   fi
+   eoutdent
+
+   # finally check if we have a password we can use:
+   if [ -n "$SSH_PASSWD" ] ; then
+      echo "grml:$SSH_PASSWD" | chpasswd -m
+   fi
+
+   einfo 'Starting secure shell server in background.'
+   /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
+   /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
+   eend $?
+
+   eindent
+   ewarn 'Warning: please change the password for user grml as soon as possible!'
+   eoutdent
 fi
 }
 # }}}
@@ -1292,79 +1401,83 @@ fi
 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
 config_homedir(){
 if checkbootparam home ; then
-HOMEDIR="$(getbootparam home)"
-MYHOMEDEVICE=""
-MYHOMEMOUNTPOINT=""
-MYHOMEDIR=""
-if [ -n "$HOMEDIR" ]; then
-  einfo "Bootoption home detected." && eend 0
-  case "$HOMEDIR" in
-    /dev/*)
-    MYHOMEDEVICE="${HOMEDIR##/dev/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
-  ;;
-    /mnt/*)
-    MYHOMEDEVICE="${HOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-    MYHOMEDIR="$HOMEDIR"
-  ;;
-    [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
-    MYHOMEDIR="$(findfile grml.img)"
-    MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
-    MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
-    MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
-  ;;
-  *)
-    eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
-    eerror "Option ignored." ; eend 1
-  ;;
-  esac
-fi
-
-if [ -n "$MYHOMEDIR" ]; then
-  if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
-    [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
-    while read device mountpoint fs relax; do
-      case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
-        case "$fs" in *[Nn][Tt][Ff][Ss]*)
-          umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
-          break
-        ;;
-        *[Ff][Aa][Tt]*)
-        # Note: This currently won't work with encrypted partitions
-        umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
-        if [ ! -f "$MYHOMEDIR" ]; then
-          ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
-          ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
-        fi
-        ;;
-      esac
-      if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
-        einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
-        if [ -f "$MYHOMEDIR" ]; then
-          # It's a loopback file, mount it over the /home/grml directory
-          trymount "$MYHOMEDIR" /home/grml
-          RC="$?"
-          [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
-          RC="$?"
-        else
-          # Do a --bind mount
-          ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
-          RC="$?"
-        fi
-        [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
-      fi
-      break
+   HOMEDIR="$(getbootparam home)"
+   MYHOMEDEVICE=""
+   MYHOMEMOUNTPOINT=""
+   MYHOMEDIR=""
+   if [ -n "$HOMEDIR" ]; then
+      einfo "Bootoption home detected." && eend 0
+      case "$HOMEDIR" in
+        /dev/*)
+        MYHOMEDEVICE="${HOMEDIR##/dev/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
+      ;;
+        /mnt/*)
+        MYHOMEDEVICE="${HOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
+        MYHOMEDIR="$HOMEDIR"
+      ;;
+        [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
+        MYHOMEDIR="$(findfile grml.img)"
+        MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
+        MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
+        MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
       ;;
-    esac
-  done <<EOT
-$(cat /proc/mounts)
+      *)
+        eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
+        eerror "Option ignored." ; eend 1
+      ;;
+      esac
+   fi # -n $HOMEDIR
+
+   if [ -n "$MYHOMEDIR" ]; then
+      if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
+         [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
+         while read device mountpoint fs relax; do
+           case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+             case "$fs" in
+               *[Nn][Tt][Ff][Ss]*)
+                 umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
+                 break
+                 ;;
+               *[Ff][Aa][Tt]*)
+                 # Note: This currently won't work with encrypted partitions
+                 umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
+                 if [ ! -f "$MYHOMEDIR" ]; then
+                    ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
+                    ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
+                 fi
+                 ;;
+             esac
+
+             if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
+                einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
+                if [ -f "$MYHOMEDIR" ]; then
+                   # It's a loopback file, mount it over the /home/grml directory
+                   trymount "$MYHOMEDIR" /home/grml
+                   RC="$?"
+                   [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
+                   RC="$?"
+                else
+                   # Do a --bind mount
+                   ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
+                   RC="$?"
+                fi # -f $MYHOMEDIR
+
+                [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
+
+             fi #  mount -o remount,rw,...
+           break
+           ;;
+           esac # case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
+         done <<EOT
+         $(cat /proc/mounts)
 EOT
-  fi
-fi
+     fi # if trymount ...
+   fi # -n $MYHOMEDIR
 fi # checkbootparam home
 }
 # }}}
@@ -1372,10 +1485,10 @@ fi # checkbootparam home
 # {{{ Check for scripts on CD-ROM
 config_cdrom_scripts(){
 if checkbootparam "script"; then
-  for script in /cdrom/scripts/* ; do
-    einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
-    . $script
-  done
+   for script in "${LIVECD_PATH}"/scripts/* ; do
+       einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
+       . $script
+   done
 fi
 }
 # }}}
@@ -1386,6 +1499,11 @@ if ! [ -x /usr/bin/aumix ] ; then
   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
 else
 
+  if ! [ -r /proc/asound/cards ] ; then
+     ewarn "No soundcard present, skipping mixer settings therefore." ; eend 0
+     return
+  fi
+
   if checkbootparam vol ; then
     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
     if [ -z "$VOL" ] ; then
@@ -1421,10 +1539,18 @@ else
             amixer set Front ${VOL}% 1>/dev/null
          fi
       fi
-      ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $VOL 2>&1) ; RC=$?
+      # by default assume '0' as volume for microphone:
+      if checkbootparam micvol ; then
+         MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
+      else
+         MICVOL=0
+      fi
+
+      # finally set the volumes:
+      ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $MICVOL 2>&1) ; RC=$?
       if [ -n "$ERROR" ] ; then
          eindent
-         eerror "Problem setting mixer volumes: $ERROR"
+         eerror "Problem setting mixer volumes: $ERROR (no soundcard?)"
          eoutdent
       fi
       eend $RC
@@ -1440,11 +1566,10 @@ if checkbootparam "nomodem"; then
   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
 else
   if [ -x /etc/init.d/sl-modem-daemon ] ; then
-   if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
-     einfo "AC97 modem controller detected. Starting sl-modem-daemon in background."
-     /etc/init.d/sl-modem-daemon start >>$DEBUG &
-     eend 0
-   fi
+     if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
+        einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
+        eend 0
+     fi
   fi
 fi
 }
@@ -1513,11 +1638,22 @@ config_wondershaper(){
 # {{{ syslog-ng
 config_syslog(){
  if checkbootparam "nosyslog"; then
-  ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
+    ewarn "Not starting syslog daemon as requested on boot commandline." ; eend 0
  else
-  einfo "Starting syslog-ng in background."
-  /etc/init.d/syslog-ng start 1>>$DEBUG &
-  eend 0
+    SYSLOGD=''
+    [ -x /etc/init.d/syslog-ng ] && SYSLOGD='syslog-ng'
+    [ -x /etc/init.d/rsyslog   ] && SYSLOGD='rsyslog'
+    [ -x /etc/init.d/dsyslog   ] && SYSLOGD='dsyslog'
+    [ -x /etc/init.d/sysklogd  ] && SYSLOGD='sysklogd'
+    [ -x /etc/init.d/inetutils-syslogd ] && SYSLOGD='inetutils-syslogd'
+
+    if [ -z "$SYSLOGD" ] ; then
+       eerror "No syslog daemon found." ; eend 1
+    else
+       einfo "Starting $SYSLOGD in background."
+       /etc/init.d/$SYSLOGD start 1>>$DEBUG &
+       eend 0
+    fi
  fi
 }
 # }}}
@@ -1527,10 +1663,14 @@ config_gpm(){
  if checkbootparam "nogpm"; then
   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
  else
-  einfo "Starting gpm in background."
-#  /etc/init.d/gpm start 1>>$DEBUG &
-  ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
-  eend 0
+   if ! [ -r /dev/input/mice ] ; then
+      eerror "No mouse found - not starting GPM." ; eend 1
+   else
+      einfo "Starting gpm in background."
+      /etc/init.d/gpm start 1>>$DEBUG &
+      # ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
+      eend 0
+   fi
  fi
 }
 # }}}
@@ -1632,8 +1772,13 @@ sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
 EOF
    chmod 755 /etc/init.d/xstartup
 
-   sed -i 's#^6:.*#6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"#' /etc/inittab
-   
+   # adjust inittab for xstartup
+   if grep -q '^6:' /etc/inittab ; then
+      sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"|' /etc/inittab
+   else # just append tty6 to inittab if no definition is present:
+      echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"' >> /etc/inittab
+   fi
+
    /sbin/telinit q ; eend $?
 
    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
@@ -1663,17 +1808,17 @@ fi
 }
 
 config_automount(){
-if checkbootparam noautoconfig -o checkbootparam forensic ; then
+if checkbootparam noautoconfig || checkbootparam forensic ; then
   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
 else
  if [ -z "$INSTALLED" ] ; then
-  einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
+  einfo "Searching for device(s) labeled with GRMLCFG. (Disable this via boot option: noautoconfig)" ; eend 0
   eindent
   [ -d /mnt/grml ] || mkdir /mnt/grml
   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
 # We do need the following fix so floppy disk is available to blkid in any case :-/
   if [ -r /dev/fd0 ] ; then
-     einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
+     einfo "Floppy device detected. Trying to access floppy disk."
 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
         blkid /dev/fd0 1>>$DEBUG 2>&1
@@ -1717,7 +1862,7 @@ if checkbootparam "config" ; then
   einfo "Bootoption config found. config is set to: $CONFIG"
   eindent
     einfo "Trying to extract configuration file ${CONFIG}:"
-    cd / && unp /cdrom/config/$CONFIG $EXTRACTOPTIONS ; eend $?
+    cd / && unp "${LIVECD_PATH}"/config/$CONFIG $EXTRACTOPTIONS ; eend $?
   eoutdent
 fi
 
@@ -1786,18 +1931,39 @@ fi
 # {{{ /cdrom/.*-options
 config_debs(){
 if checkbootparam "debs" ; then
-  DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
-  einfo "Tring to install debian package(s) ${DEBS}"
-  dpkg -i /cdrom/debs/$DEBS* ; eend $?
+   DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
+   einfo "Tring to install debian package(s) ${DEBS}"
+   dpkg -i "${LIVECD_PATH}"/debs/$DEBS* ; eend $?
 fi
 }
 
 config_scripts(){
 if checkbootparam "scripts" ; then
-  SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
-  [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
-  einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
-  sh -c /cdrom/scripts/$SCRIPTS ; eend $?
+   SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
+   [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
+   einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
+   sh -c "${LIVECD_PATH}"/scripts/$SCRIPTS ; eend $?
+fi
+}
+# }}}
+
+# {{{ mypath
+config_mypath(){
+if checkbootparam "mypath" ; then
+   MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
+   einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
+   touch /etc/grml/my_path
+   chmod 644 /etc/grml/my_path
+   # make sure the directories exist:
+   eindent
+   for i in $(echo $MY_PATH | sed 's/:/\n/g') ; do
+       if ! [ -d "$i" ] ; then
+          einfo "Creating directory $i"
+          mkdir -p "$i" ; eend $?
+       fi
+   done
+   grep -q "${MY_PATH}" /etc/grml/my_path || echo "${MY_PATH}" >> /etc/grml/my_path ; eend $?
+   eoutdent
 fi
 }
 # }}}
@@ -1944,8 +2110,8 @@ fi
 config_swraid(){
   if [ -z "$INSTALLED" ] ; then
   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
-  if checkbootparam 'noraid'   -o checkbootparam 'noswraid' -o \
-     checkbootparam 'forensic' -o checkbootparam 'raid=noautodetect' ; then
+  if checkbootparam 'noraid'   || checkbootparam 'noswraid' -o \
+     checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
   else
     if ! [ -x /sbin/mdadm ] ; then
@@ -2009,6 +2175,34 @@ config_swraid(){
 }
 # }}}
 
+# {{{ LVM (Logical Volumes)
+config_lvm(){
+  if [ -z "$INSTALLED" ] ; then
+  # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
+  if checkbootparam 'nolvm' ; then
+     ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
+  else
+    # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
+    if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
+       eerror "LVM not available, can not execute it." ; eend 1
+    else
+       if lvdisplay 2>&1 | grep -v 'No volume groups found' 1>/dev/null 2>&1 ; then
+          einfo "You seem to have logical volumes (LVM) on your system."
+          eindent
+          einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
+          eend 0
+          if checkbootparam 'lvm' ; then
+             einfo "Bootoption LVM found. Searching for logical volumes:"
+             /etc/init.d/lvm2 start ; eend $?
+          fi
+          eoutdent
+       fi
+    fi # check for lvm binary
+  fi # check for bootoption nolvm
+  fi # run only in live-cd mode
+}
+# }}}
+
 # {{{ debnet: setup network based on an existing one found on a partition
 config_debnet(){
 if checkbootparam "debnet" ; then
@@ -2055,6 +2249,19 @@ fi
 }
 # }}}
 
+# {{{ check for broken ipw3945 driver which causes problems (especially on hd install)
+config_ipw3945() {
+  if grep -q ipw3945 /proc/modules ; then
+     if ! iwconfig 2>/dev/null| grep -qe 'IEEE 802' -qe 'unassociated' ; then
+        ewarn "Broken ipw3945 network interface found, reloading module."
+        rmmod ipw3945
+        modprobe ipw3945
+        eend $?
+     fi
+  fi
+}
+# }}}
+
 # {{{ disable console blanking
 config_blanking(){
 if checkbootparam "noblank" ; then
 # {{{ grml2hd: automatic installation
 config_grml2hd(){
 
+if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
+
 if checkbootparam "user" ; then
-  NEWUSER=''
-  NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
-  sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   NEWUSER=''
+   NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
+   sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
 if checkbootparam "filesystem" ; then
-  FILESYSTEM=''
-  FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
-  sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   FILESYSTEM=''
+   FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
+   sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
 if checkbootparam "partition" ; then
-  PARTITION=''
-  PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
-  # notice: the following checks whether the given partition is available, if not the skip
-  # execution of grml2hd as it might result in data loss...
-  if [ -r $PARTITION ] ; then
-    sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
-  else
-    ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
-  fi
+   PARTITION=''
+   PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
+   # notice: the following checks whether the given partition is available, if not the skip
+   # execution of grml2hd as it might result in data loss...
+   if [ -r $PARTITION ] ; then
+      sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   else
+      ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
+   fi
 fi
 
 if checkbootparam "mbr" ; then
-  BOOT_PARTITION=''
-  BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
-  sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
+   BOOT_PARTITION=''
+   BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
+   sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
 fi
 
-if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
-  cat>|/usr/bin/grml2hd_noninteractive<<EOF
+cat>|/usr/bin/grml2hd_noninteractive<<EOF
 #!/bin/sh
 GRML2HD_NONINTERACTIVE='yes' grml2hd
 EOF
-  chmod 755 /usr/bin/grml2hd_noninteractive
-  einfo "Bootparameter grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
-  if [ -z "$GRML2HD_FAIL" ] ; then
-    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
-  else
-    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
+
+chmod 755 /usr/bin/grml2hd_noninteractive
+einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
+if [ -z "$GRML2HD_FAIL" ] ; then
+   screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
+else
+   ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
+fi
+
+fi # if stringinstring "BOOT_IMAGE=grml2hd ...
+}
+# }}}
+
+# {{{ debootstrap: automatic installation
+config_debootstrap(){
+
+if stringinstring "BOOT_IMAGE=debian2hd " "$CMDLINE" ; then
+
+einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
+
+if ! [ -x /usr/sbin/grml-debootstrap ] ; then
+   eindent
+   eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
+   eoutdent
+   exit 1
+fi
+
+if checkbootparam "target" ; then
+  TARGET=''
+  TARGET="$(getbootparam 'target' 2>>$DEBUG)"
+  # notice: the following checks whether the given partition is available, if not the skip
+  # execution of grml-debootstrap as it might result in data loss...
+  if ! [ -r "$TARGET" ] ; then
+     eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
+  fi
+else
+  eindent
+  eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
+  eoutdent
+  exit 1
+fi
+
+if checkbootparam "grub" ; then
+  GRUB=''
+  GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
+fi
+
+if checkbootparam "groot" ; then
+  GROOT=''
+  GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
+fi
+
+if checkbootparam "release" ; then
+  RELEASE=''
+  RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
+fi
+
+if checkbootparam "mirror" ; then
+  MIRROR=''
+  MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
+fi
+
+if checkbootparam "boot_append" ; then
+  BOOT_APPEND=''
+  BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
+fi
+
+if checkbootparam "password" ; then
+  PASSWORD=''
+  PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
+fi
+
+# now check which options are available
+if [ -n "TARGET" ] ; then
+   TARGETCMD="--target $TARGET"
+else
+   TARGETCMD=''
+   eindent
+   eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
+   eoutdent
+   exit 1
+fi
+[ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
+[ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
+[ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
+[ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
+[ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
+[ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
+
+# and finally write script and execute it
+cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
+#!/bin/sh
+AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
+EOF
+
+chmod 750  /usr/bin/grml-debootstrap_noninteractive
+
+screen /usr/bin/grml-debootstrap_noninteractive
+einfo "Invoking a shell, just exit to continue booting..."
+/bin/zsh
+
+fi # stringinstring "BOOT_IMAGE=debian2hd
+}
+# }}}
+
+# {{{ Support customization
+config_distri(){
+if checkbootparam "distri"; then
+  DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
+  if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
+     [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
+     # make sure the desktop.jpg file is not a symlink, so copying does not file then
+     [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
+     cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
   fi
 fi
 }
@@ -2123,4 +2439,4 @@ config_keyboard(){
 # }}}
 
 ## END OF FILE #################################################################
-# vim:foldmethod=marker
+# vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3